diff -ruN ../nakedmudv3.7/src/command.h src/command.h
--- ../nakedmudv3.7/src/command.h	2008-05-31 00:17:59.000000000 -0400
+++ src/command.h	2009-03-02 01:00:31.000000000 -0500
@@ -28,11 +28,22 @@
 CMD_DATA *newPyCmd(const char *name, void  *pyfunc, const char *user_group,
 		   bool interrupts);
 
+//
+// change our information, without changing our checks
+void   cmdUpdate(CMD_DATA *cmd, COMMAND(func), const char *user_group, 
+		 bool interrupts);
+void cmdPyUpdate(CMD_DATA *cmd, void *pyfunc, const char *user_group,
+		 bool interrupts);
+
 void     deleteCmd(CMD_DATA *cmd);
 CMD_DATA  *cmdCopy(CMD_DATA *cmd);
 void     cmdCopyTo(CMD_DATA *from, CMD_DATA *to);
 
-bool    charTryCmd(CHAR_DATA *ch, CMD_DATA *cmd, char *arg);
+//
+// -1     did not attempt; no command but all checks passed (fail)
+//  0     attempted, but a check stopped it (success)
+//  1     attempted, and succeeded (success)
+int charTryCmd(CHAR_DATA *ch, CMD_DATA *cmd, char *arg);
 
 const char      *cmdGetName(CMD_DATA *cmd);
 const char *cmdGetUserGroup(CMD_DATA *cmd);
@@ -40,6 +51,10 @@
 void            cmdAddCheck(CMD_DATA *cmd, CMD_CHK(func));
 void          cmdAddPyCheck(CMD_DATA *cmd, void *pyfunc);
 
+//
+// do we have an associated function, or are we just a list of command checks?
+bool cmdHasFunc(CMD_DATA *cmd);
+
 CMD_CHK(chk_can_move);     // ensures the person is standing
 CMD_CHK(chk_conscious);    // ensures the person is conscious
 CMD_CHK(chk_grounded);     // ensures the person is on the ground
diff -ruN ../nakedmudv3.7/src/editor/editor.c src/editor/editor.c
--- ../nakedmudv3.7/src/editor/editor.c	2008-05-31 00:17:59.000000000 -0400
+++ src/editor/editor.c	2009-03-02 01:00:31.000000000 -0500
@@ -19,12 +19,22 @@
 
 
 //*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../scripts/scripts.h"
+#include "../scripts/pyplugs.h"
+
+
+
+//*****************************************************************************
 // auxiliary data for sockets
 //*****************************************************************************
 typedef struct editor_aux_data {
-  EDITOR *editor;      // the editor we're using
-  BUFFER *buf;         // the buffer we're editing
-  BUFFER *working_buf; // the buffer where we do our work
+  EDITOR   *editor;      // the editor we're using
+  BUFFER   *buf;         // the buffer we're editing (if any)
+  BUFFER   *working_buf; // the buffer where we do our work
+  PyObject *py_complete; // python function to call on completion of editing
+  void    (* on_complete)(SOCKET_DATA *sock, const char *str);
 } EDITOR_AUX_DATA;
 
 EDITOR_AUX_DATA *newEditorAuxData() {
@@ -37,14 +47,18 @@
   // if we have a working buf, free it. Don't touch anything else. that
   // stuff will be needed by the rest of the program
   if(data->working_buf) deleteBuffer(data->working_buf);
+  if(data->py_complete) { Py_DECREF(data->py_complete); }
   free(data);
 }
 
 void clearEditorAuxData(EDITOR_AUX_DATA *data) {
   if(data->working_buf) deleteBuffer(data->working_buf);
+  if(data->py_complete) { Py_DECREF(data->py_complete); }
   data->working_buf = NULL;
   data->editor      = NULL;
   data->buf         = NULL;
+  data->on_complete = NULL;
+  data->py_complete = NULL;
 }
 
 
@@ -54,6 +68,7 @@
 //*****************************************************************************
 // a basic text editor for use by other modules
 EDITOR *text_editor = NULL;
+
 // an editor for dialog. Essentially, text without newlines
 EDITOR *dialog_editor = NULL;
 
@@ -102,9 +117,9 @@
 //
 void editorDefaultHeader(SOCKET_DATA *sock) {
   text_to_buffer(sock, 
-"==========================================================================\r\n"
+"================================================================================\r\n"
 "Begin editing. /q on a new line to quit, /a to abort. /h for help         \r\n"
-"==========================================================================\r\n"
+"================================================================================\r\n"
 		 );
 }
 
@@ -160,7 +175,18 @@
 void editorQuit(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
   // save the current changes
   EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "editor_aux_data");
-  bufferCopyTo(buf, data->buf);
+  if(data->on_complete)
+    data->on_complete(sock, bufferString(buf));
+  else if(data->py_complete) {
+    PyObject *ret = PyObject_CallFunction(data->py_complete, "Os", 
+					  socketGetPyFormBorrowed(sock),
+					  bufferString(buf));
+    if(ret == NULL)
+      log_pyerr("Error quitting the buffer editor.");
+    Py_XDECREF(ret);
+  }
+
+  //bufferCopyTo(buf, data->buf);
   clearEditorAuxData(data);
   text_to_buffer(sock, "Saved and quit.\r\n");
   // and then pop the input handler
@@ -368,23 +394,55 @@
   }
 }
 
-void socketStartEditor(SOCKET_DATA *sock, EDITOR *editor, BUFFER *buf) {
+void dflt_editor_complete(SOCKET_DATA *sock, const char *str) {
   EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "editor_aux_data"); 
-  data->working_buf = bufferCopy(buf);
-  data->buf         = buf;
-  data->editor      = editor;
-  if(editor->init) editor->init(sock);
+  bufferClear(data->buf);
+  bufferCat(data->buf, str);
+}
+
+void begin_editor(SOCKET_DATA *sock) {
+  EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "editor_aux_data"); 
+  if(data->editor->init) data->editor->init(sock);
 
   editorDefaultHeader(sock);
   
   // if we have a "list" command, execute it. Otherwise, cat the buf
   ECMD_DATA *list = NULL;
-  if((list = hashGet(editor->cmds, "l")) != NULL)
-    list->func(sock, "", buf);
+  if((list = hashGet(data->editor->cmds, "l")) != NULL)
+    list->func(sock, "", data->working_buf);
   else
-    text_to_buffer(sock, bufferString(buf));
+    text_to_buffer(sock, bufferString(data->working_buf));
+
+  socketPushInputHandler(sock, editorInputHandler, data->editor->prompt, 
+			 "text editor");
+}
+
+void socketStartPyEditorFunc(SOCKET_DATA *sock, EDITOR *editor,const char *dflt,
+			     void *py_complete) {
+  EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "editor_aux_data"); 
+  data->working_buf = newBuffer(1);
+  bufferCat(data->working_buf, dflt);
+  data->editor      = editor;
+  data->py_complete = py_complete;
+  Py_XINCREF(data->py_complete);
+  begin_editor(sock);
+}
 
-  socketPushInputHandler(sock, editorInputHandler, editor->prompt);
+void socketStartEditorFunc(SOCKET_DATA *sock, EDITOR *editor, const char *dflt,
+			   void (* on_complete)(SOCKET_DATA *, const char *)) {
+  EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "editor_aux_data"); 
+  data->working_buf = newBuffer(1);
+  bufferCat(data->working_buf, dflt);
+  data->editor      = editor;
+  data->on_complete = on_complete;
+  if(editor->init) editor->init(sock);
+  begin_editor(sock);
+}
+
+void socketStartEditor(SOCKET_DATA *sock, EDITOR *editor, BUFFER *buf) {
+  EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "editor_aux_data"); 
+  data->buf         = buf;
+  socketStartEditorFunc(sock, editor, bufferString(buf), dflt_editor_complete);
 }
 
 EDITOR *socketGetEditor(SOCKET_DATA *sock) {
diff -ruN ../nakedmudv3.7/src/editor/editor.h src/editor/editor.h
--- ../nakedmudv3.7/src/editor/editor.h	2008-05-31 00:17:59.000000000 -0400
+++ src/editor/editor.h	2009-03-02 01:00:31.000000000 -0500
@@ -80,6 +80,14 @@
 void socketStartEditor(SOCKET_DATA *sock, EDITOR *editor, BUFFER *buf);
 
 //
+// begin editing text. Instead of copying the results to a buffer after
+// completion, call a function which will pass in the resulting text.
+void socketStartEditorFunc(SOCKET_DATA *sock, EDITOR *editor, const char *dflt,
+			   void (* on_complete)(SOCKET_DATA *, const char *));
+void socketStartPyEditorFunc(SOCKET_DATA *sock, EDITOR *editor,const char *dflt,
+			     void *py_complete);
+
+//
 // get a pointer to the current editor the socket is using, if any
 EDITOR *socketGetEditor(SOCKET_DATA *sock);
 
diff -ruN ../nakedmudv3.7/src/event.c src/event.c
--- ../nakedmudv3.7/src/event.c	2008-05-31 00:17:59.000000000 -0400
+++ src/event.c	2009-03-02 01:00:31.000000000 -0500
@@ -37,33 +37,6 @@
 
 
 
-
-//******************************************************************************
-//
-// a small test for delayed events ... proof of concept
-//
-//******************************************************************************
-void devent_on_complete(CHAR_DATA *owner, void *data, char *arg) {
-  communicate(owner, arg, COMM_GLOBAL);
-}
-
-bool check_devent_involvement(void *thing, void *data) {
-  return (thing == data);
-}
-
-COMMAND(cmd_devent) {
-  if(!*arg)
-    send_to_char(ch, "What did you want to delay-chat?\r\n");
-  else {
-    start_event(ch,
-		5 SECONDS,
-		devent_on_complete, check_devent_involvement, 
-		ch, arg);
-  }
-}
-
-
-
 //*****************************************************************************
 //
 // event handling
@@ -122,9 +95,6 @@
 void init_events() {
   events = newList();
 
-  // add our proof of concept command
-  add_cmd("devent", NULL, cmd_devent, "admin", FALSE);
-
   // make sure all events involving the object/char are cancelled when
   // either is extracted from the game
   hookAdd("obj_from_game",  interrupt_events_obj_hook);
@@ -158,8 +128,15 @@
 		 void *check_involvement,
 		 void *data,
 		 const char *arg) {
-  listPut(events, newEvent(owner, delay, on_complete, check_involvement,
-			   data, arg, FALSE));
+  // some events might cause other events to activate. This is signaled by
+  // providing a delay of 0. In this case, we queue events to the back of the
+  // event list instead of push them on to the front
+  EVENT_DATA *event = newEvent(owner, delay, on_complete, check_involvement,
+			       data, arg, FALSE);
+  if(delay == 0)
+    listQueue(events, event);
+  else
+    listPut(events, event);
 }
 
 void start_update(void *owner, 
@@ -201,6 +178,5 @@
       else
 	deleteEvent(event);
     }
-  }
-  deleteListIterator(ev_i);
+  } deleteListIterator(ev_i);
 }
diff -ruN ../nakedmudv3.7/src/exit.c src/exit.c
--- ../nakedmudv3.7/src/exit.c	2008-05-31 00:17:59.000000000 -0400
+++ src/exit.c	2009-03-02 01:00:31.000000000 -0500
@@ -13,14 +13,9 @@
 
 #define EX_CLOSED            (1 << 0)
 #define EX_LOCKED            (1 << 1)
+#define EX_CLOSABLE          (1 << 2)
 // lockable is handled if the exit has a key
 
-
-// exit UIDs (unique IDs) start at a million and go 
-// up by one every time a new exit is created
-#define START_EXIT_UID       1000000
-int next_exit_uid  =   START_EXIT_UID;
-
 struct exit_data {
   char *name;              // what is the name of our door for descriptions?
   char *keywords;          // what keywords can the door be referenced by?
@@ -35,7 +30,6 @@
 
   bitvector_t status;      // closable, closed, locked, etc...
 
-  int closable;            // is the exit closable?
   int hide_lev;            // how hidden is this exit?
   int pick_lev;            // how hard is it to pick this exit?
   int uid;                 // our unique identification number
@@ -56,9 +50,8 @@
   exit->hide_lev    = 0;
   exit->pick_lev    = 0;
   exit->status      = 0;
-  exit->closable    = FALSE;
   exit->room        = NULL;
-  exit->uid         = next_exit_uid++;
+  exit->uid         = next_uid();
   return exit;
 };
 
@@ -113,7 +106,9 @@
   exitSetKey(exit,       read_string(set, "key"));
   exitSetHidden(exit,    read_int   (set, "hide_level"));
   exitSetPickLev(exit,   read_int   (set, "pick_level"));
-  exitSetClosable(exit,  read_int   (set, "closable"));
+  exitSetClosable(exit,  read_bool  (set, "closable"));
+  exitSetClosed(exit,    read_bool  (set, "closed"));
+  exitSetLocked(exit,    read_bool  (set, "locked"));
   return exit;
 }
 
@@ -129,7 +124,9 @@
   store_string(set, "key",        exit->key);
   store_int   (set, "hide_level", exit->hide_lev);
   store_int   (set, "pick_level", exit->pick_lev);
-  store_int   (set, "closable",   exit->closable);
+  store_bool  (set, "closable",   exitIsClosable(exit));
+  store_bool  (set, "closed",     exitIsClosed(exit));
+  store_bool  (set, "locked",     exitIsLocked(exit));
   return set;
 }
 
@@ -139,7 +136,7 @@
 // is, get and set functions
 //*****************************************************************************
 bool        exitIsClosable(const EXIT_DATA *exit) {
-  return exit->closable;
+  return IS_SET(exit->status, EX_CLOSABLE);
 };
 
 bool        exitIsClosed(const EXIT_DATA *exit) {
@@ -207,7 +204,8 @@
 }
 
 void        exitSetClosable(EXIT_DATA *exit, bool closable) {
-  exit->closable = (closable != 0);
+  if(closable) SET_BIT(exit->status, EX_CLOSABLE);
+  else         REMOVE_BIT(exit->status, EX_CLOSABLE);
 }
 
 void        exitSetClosed(EXIT_DATA *exit, bool closed) {
diff -ruN ../nakedmudv3.7/src/extra_descs.c src/extra_descs.c
--- ../nakedmudv3.7/src/extra_descs.c	2008-05-31 00:17:59.000000000 -0400
+++ src/extra_descs.c	2009-03-02 01:00:32.000000000 -0500
@@ -31,9 +31,9 @@
 // edesc set
 //
 //*****************************************************************************
-EDESC_SET  *newEdescSet         () {
+EDESC_SET  *newEdescSet() {
   EDESC_SET *set = malloc(sizeof(EDESC_SET));
-  set->edescs = newList();
+  set->edescs    = NULL;
   return set;
 }
 
@@ -50,65 +50,84 @@
 
 EDESC_SET *edescSetRead(STORAGE_SET *set) {
   EDESC_SET      *edescs = newEdescSet();
-  STORAGE_SET_LIST *list = read_list(set, "list");
-  deleteList(edescs->edescs);
-  edescs->edescs = gen_read_list(list, edescRead);
-  LIST_ITERATOR *list_i = newListIterator(edescs->edescs);
-  EDESC_DATA     *edesc = NULL;
-  ITERATE_LIST(edesc, list_i)
-    edesc->set = edescs;
-  deleteListIterator(list_i);
+  if(storage_contains(set, "list")) {
+    STORAGE_SET_LIST *list = read_list(set, "list");
+    // deleteList(edescs->edescs);
+    edescs->edescs = gen_read_list(list, edescRead);
+    LIST_ITERATOR *list_i = newListIterator(edescs->edescs);
+    EDESC_DATA     *edesc = NULL;
+    ITERATE_LIST(edesc, list_i) {
+      edesc->set = edescs;
+    } deleteListIterator(list_i);
+  }
   return edescs;
 }
 
 
 STORAGE_SET *edescSetStore(EDESC_SET *edescs) {
-  STORAGE_SET *set             = new_storage_set();
-  store_list(set, "list", gen_store_list(edescs->edescs, edescStore));
+  STORAGE_SET *set = new_storage_set();
+  if(edescs->edescs != NULL)
+    store_list(set, "list", gen_store_list(edescs->edescs, edescStore));
   return set;
 }
 
-
 void edescSetCopyTo(EDESC_SET *from, EDESC_SET *to) {
   // delete all of the current entries
-  deleteListWith(to->edescs, deleteEdesc);
-  to->edescs = listCopyWith(from->edescs, edescCopy);
+  if(to->edescs != NULL) {
+    deleteListWith(to->edescs, deleteEdesc);
+    to->edescs = NULL;
+  }
+  if(from->edescs != NULL) {
+    to->edescs = listCopyWith(from->edescs, edescCopy);
+    LIST_ITERATOR *list_i = newListIterator(to->edescs);
+    EDESC_DATA     *edesc = NULL;
+    ITERATE_LIST(edesc, list_i) {
+      edesc->set = to;
+    } deleteListIterator(list_i);
+  }
 }
 
-
 EDESC_SET *edescSetCopy(EDESC_SET *set) {
   EDESC_SET *newset = newEdescSet();
   edescSetCopyTo(set, newset);
   return newset;
 }
 
-EDESC_DATA *edescSetGet            (EDESC_SET *set, const char *keyword) {
+EDESC_DATA *edescSetGet(EDESC_SET *set, const char *keyword) {
+  if(set->edescs == NULL)
+    return NULL;
+
   LIST_ITERATOR *edesc_i = newListIterator(set->edescs);
   EDESC_DATA       *desc = NULL;
 
-  ITERATE_LIST(desc, edesc_i)
+  ITERATE_LIST(desc, edesc_i) {
     if(edescIsKeyword(desc, keyword))
       break;
-  
-  deleteListIterator(edesc_i);
+  } deleteListIterator(edesc_i);
   return desc;
 }
 
-void        edescSetPut         (EDESC_SET *set, EDESC_DATA *edesc) {
+void edescSetPut(EDESC_SET *set, EDESC_DATA *edesc) {
+  if(set->edescs == NULL)
+    set->edescs = newList();
   edesc->set = set;
   listQueue(set->edescs, edesc);
 }
 
-EDESC_DATA *edescSetGetNum         (EDESC_SET *set, int num) {
+EDESC_DATA *edescSetGetNum(EDESC_SET *set, int num) {
+  if(set->edescs == NULL)
+    return NULL;
   return listGet(set->edescs, num);
 }
 
-void removeEdesc         (EDESC_SET *set, EDESC_DATA *edesc) {
-  if(listRemove(set->edescs, edesc))
+void removeEdesc(EDESC_SET *set, EDESC_DATA *edesc) {
+  if(set->edescs != NULL && listRemove(set->edescs, edesc))
     edesc->set = NULL;
 }
 
-EDESC_DATA *edescSetRemove    (EDESC_SET *set, const char *keyword) {
+EDESC_DATA *edescSetRemove(EDESC_SET *set, const char *keyword) {
+  if(set->edescs == NULL)
+    return NULL;
   EDESC_DATA *entry = edescSetGet(set, keyword);
   if(entry && listRemove(set->edescs, entry))
     entry->set = NULL;
@@ -116,27 +135,36 @@
 }
 
 EDESC_DATA *edescSetRemoveNum (EDESC_SET *set, int num) {
+  if(set->edescs == NULL)
+    return NULL;
+
   EDESC_DATA *entry = listRemoveNum(set->edescs, num);
   if(entry)
     entry->set = NULL;
   return entry;
 }
 
-void        deleteEdescSet      (EDESC_SET *set) {
-  deleteListWith(set->edescs, deleteEdesc);
+void deleteEdescSet(EDESC_SET *set) {
+  if(set->edescs)
+    deleteListWith(set->edescs, deleteEdesc);
   free(set);
 }
 
-int         edescGetSetSize     (EDESC_SET *set) {
-  return listSize(set->edescs);
+int edescGetSetSize(EDESC_SET *set) {
+  if(set->edescs)
+    return listSize(set->edescs);
+  return 0;
 }
 
-LIST       *edescSetGetList        (EDESC_SET *set) {
+LIST *edescSetGetList(EDESC_SET *set) {
   return set->edescs;
 }
 
 void edescTagDesc(BUFFER *buf, EDESC_SET *set, 
 		  const char *start_tag, const char *end_tag) {
+  if(set->edescs == NULL)
+    return;
+
   LIST_ITERATOR *list_i = newListIterator(set->edescs);
   EDESC_DATA    *edesc  = NULL;
 
diff -ruN ../nakedmudv3.7/src/filebuf.c src/filebuf.c
--- ../nakedmudv3.7/src/filebuf.c	1969-12-31 19:00:00.000000000 -0500
+++ src/filebuf.c	2009-03-02 01:00:32.000000000 -0500
@@ -0,0 +1,131 @@
+//*****************************************************************************
+//
+// filebuf.h
+//
+// buffered file io
+//
+//*****************************************************************************
+
+#include <stdio.h>
+#include <time.h>
+#include "mud.h"
+
+
+
+//*****************************************************************************
+// local structures and defines
+//*****************************************************************************
+
+#define FBMODE_READ              0
+#define FBMODE_WRITE             1
+
+struct buffered_file {
+  FILE    *fl;
+  BUFFER *buf;
+  int     pos;
+  int    mode;
+};
+
+//
+// buffer up input from our file
+void fb_buffer(FILEBUF *fb) {
+  if(feof(fb->fl))
+    return;
+
+  char in[MAX_BUFFER+1];
+  int amnt;
+  do {
+    amnt = fread(in, sizeof(char), MAX_BUFFER, fb->fl);
+    in[amnt] = '\0';
+    bufferCat(fb->buf, in);
+  } while(amnt == MAX_BUFFER);
+}
+
+FILEBUF *fbopen(const char *fname, const char *mode) {
+  // make sure we can access the file...
+  FILE *fl = fopen(fname, mode);
+  if(fl == NULL)
+    return NULL;
+
+  // clock our performance
+  // struct timeval start_time;
+  // gettimeofday(&start_time, NULL);
+
+  FILEBUF *fb = malloc(sizeof(FILEBUF));
+  fb->fl      = fl;
+  fb->buf     = newBuffer(1024);
+  fb->pos     = 0;
+
+  if(*mode == 'r') {
+    fb->mode = FBMODE_READ;
+    fb_buffer(fb);
+  }
+  else
+    fb->mode = FBMODE_WRITE;
+
+  // finish clocking performance
+  // struct timeval end_time;
+  // gettimeofday(&end_time, NULL);
+  // int usecs = (int)(end_time.tv_usec - start_time.tv_usec);
+  // int secs  = (int)(end_time.tv_sec  - start_time.tv_sec);
+  // log_string("buffer open time %d %s", (int)(secs*1000000 + usecs), fname);
+
+  return fb;
+}
+
+//
+// close, flush, and delete the buffered file reader
+void fbclose(FILEBUF *fb) {
+  fbflush(fb);
+  fclose(fb->fl);
+  deleteBuffer(fb->buf);
+  free(fb);
+}
+
+//
+// flush the buffered file reader
+void fbflush(FILEBUF *fb) {
+  if(fb->mode == FBMODE_WRITE && bufferLength(fb->buf) > fb->pos) {
+    const char *to_flush = bufferString(fb->buf);
+    fprintf(fb->fl, "%s", to_flush+fb->pos);
+    fb->pos = bufferLength(fb->buf);
+  }
+}
+
+//
+// return the next char in the buffered file
+char fbgetc(FILEBUF *fb) {
+  if(fb->pos >= bufferLength(fb->buf))
+    return EOF;
+  else
+    return bufferString(fb->buf)[fb->pos++];
+}
+
+//
+// print the formatting to the file
+int fbprintf(FILEBUF *fb, const char *fmt, ...) {
+  va_list va;
+  va_start(va, fmt);
+  int res = vbprintf(fb->buf, fmt, va);
+  va_end(va);
+  return res;
+}
+
+//
+// append the text to the buffer
+void fbwrite(FILEBUF *fb, const char *str) {
+  bufferCat(fb->buf, str);
+}
+
+//
+// go to the position, from the specified offset. Uses SEEK_CUR, SEEK_SET,
+// and SEEK_END from stdio.h
+void fbseek(FILEBUF *fb, int offset, int origin) {
+  if(origin == SEEK_SET)
+    fb->pos = 0;
+  else if(origin == SEEK_END)
+    fb->pos = bufferLength(fb->buf) - 1;
+  else if(origin != SEEK_CUR)
+    return;
+  fb->pos += offset;
+}
diff -ruN ../nakedmudv3.7/src/filebuf.h src/filebuf.h
--- ../nakedmudv3.7/src/filebuf.h	1969-12-31 19:00:00.000000000 -0500
+++ src/filebuf.h	2009-03-02 01:00:32.000000000 -0500
@@ -0,0 +1,45 @@
+#ifndef FILEBUF_H
+#define FILEBUF_H
+//*****************************************************************************
+//
+// filebuf.h
+//
+// buffered file io
+//
+//*****************************************************************************
+
+typedef struct buffered_file FILEBUF;
+
+//
+// create a new buffered file reader for reading, writing, 
+// or appending, specified by the mode
+FILEBUF *fbopen(const char *fname, const char *mode);
+
+//
+// close, flush, and delete the buffered file reader
+void fbclose(FILEBUF *buf);
+
+//
+// flush the buffered file reader
+void fbflush(FILEBUF *buf);
+
+//
+// return the next char in the buffered file
+char fbgetc(FILEBUF *buf);
+
+//
+// print the formatting to the file
+int fbprintf(FILEBUF *buf, const char *fmt, ...) 
+__attribute__ ((format (printf, 2, 3)));
+
+//
+// append the text to the buffer
+void fbwrite(FILEBUF *fb, const char *str);
+
+//
+// go to the position, from the specified offset. Uses SEEK_CUR, SEEK_SET,
+// and SEEK_END from stdio.h
+void fbseek(FILEBUF *buf, int offset, int origin);
+
+
+#endif // FILEBUF
diff -ruN ../nakedmudv3.7/src/gameloop.c src/gameloop.c
--- ../nakedmudv3.7/src/gameloop.c	2008-12-06 00:20:20.000000000 -0500
+++ src/gameloop.c	2009-03-02 01:04:26.000000000 -0500
@@ -70,13 +70,21 @@
 
 // global variables
 WORLD_DATA      *gameworld = NULL; // the gameworld, and ll the prototypes
+
 LIST          *object_list = NULL; // the list of all existing objects
 LIST          *socket_list = NULL; // the list of active sockets
 LIST          *mobile_list = NULL; // the list of existing mobiles
 LIST            *room_list = NULL; // the list of all existing rooms
+
+SET            *object_set = NULL; // same things, stored in a set
+SET            *mobile_set = NULL; // and mobiles
+SET              *room_set = NULL; // amd rooms
+
 LIST       *mobs_to_delete = NULL; // mobs pending final extraction
 LIST       *objs_to_delete = NULL; // objs pending final extraction
 LIST      *rooms_to_delete = NULL; // rooms pending final extraction
+LIST       *strs_to_delete = NULL; // strings waiting to be freed
+LIST       *bufs_to_delete = NULL; // buffers waiting to be freed
 PROPERTY_TABLE  *mob_table = NULL; // a table of mobs by UID, for quick lookup
 PROPERTY_TABLE  *obj_table = NULL; // a table of objs by UID, for quick lookup
 PROPERTY_TABLE *room_table = NULL; // a table of rooms by UID, for quick lookup
@@ -139,9 +147,16 @@
   socket_list     = newList();
   mobile_list     = newList();
   room_list       = newList();
+
+  object_set      = newSet();
+  mobile_set      = newSet();
+  room_set        = newSet();
+
   mobs_to_delete  = newList();
   objs_to_delete  = newList();
   rooms_to_delete = newList();
+  strs_to_delete  = newList();
+  bufs_to_delete  = newList();
 
   // tables for quick lookup of mobiles and objects by UID.
   // For optimal speed, the table sizes should be roughly
@@ -300,12 +315,6 @@
   /**********************************************************************/
   /*             START THE GAME UP, AND HANDLE ITS SHUTDOWN             */
   /**********************************************************************/
-
-  // Run our initialize hooks. Most C modules will have their own init
-  // functions, but some stuff may need to be set up after *all* modules are
-  // initialized
-  hookRun("initialize", "");
-
   // main game loop
   log_string("Entering game loop");
   game_loop(control);
@@ -346,14 +355,20 @@
 
   // if we have final extractions pending, do them
   CHAR_DATA *ch = NULL;
-  while((ch = listPop(mobs_to_delete)) != NULL)
+  while((ch = (CHAR_DATA *)listPop(mobs_to_delete)) != NULL)
     extract_mobile_final(ch);
   OBJ_DATA *obj = NULL;
-  while((obj = listPop(objs_to_delete)) != NULL)
+  while((obj = (OBJ_DATA *)listPop(objs_to_delete)) != NULL)
     extract_obj_final(obj);
   ROOM_DATA *room = NULL;
-  while((room = listPop(rooms_to_delete)) != NULL)
+  while((room = (ROOM_DATA *)listPop(rooms_to_delete)) != NULL)
     extract_room_final(room);
+  char *str = NULL;
+  while((str = (char *)listPop(strs_to_delete)) != NULL)
+    free(str);
+  BUFFER *buf = NULL;
+  while((buf = (BUFFER *)listPop(bufs_to_delete)) != NULL)
+    deleteBuffer(buf);
 }
 
 
